import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

Minim baby;
AudioPlayer player;

Con [] con = new Con [250];

PImage h;
float z;
float w;
float c;
float v;
int i;
int g;

void setup() {

  baby = new Minim(this);
  player = baby.loadFile("miku.mp3");
  player.play();
  h = loadImage ("hatsune.png"); 

  for (int f = 0; f < con.length; f++) {
    con[f] = new Con(random(0, 1000), -40, f);
  }

  size (1000, 1000);
  smooth();
}

void draw() {

  background (mouseX, mouseY, mouseX + mouseY);

  imageMode (CENTER);
  image (h, width/2, height/2);

  if (mousePressed) {

    for (int f = 0; f < con.length; f++) {
      con[f].move();
      con[f].display();
    }
  }

  for (int x = 0; x < player.bufferSize () - 1; x++)
  {

    noStroke();
    fill (player.left.get(x), mouseX, mouseY, 5);
    ellipse (x, player.left.get(x)*800, player.left.get(x)*800, random (50, 200));
    ellipse (x, player.right.get(x)*400, random(10, 90), random (56, 100));
  }


  for (int x = 0; x < player.bufferSize () - 1; x++)
  {
    noStroke();
    fill (player.left.get(x), mouseY, mouseX, 5);
    ellipse (player.left.get(x)*800, x, random(50, 200), random (50, 200));
    ellipse (player.right.get(x)*400, x, random(10, 90), random (56, 100));
  }

  for (int x = 0; x < player.bufferSize () - 1; x++)
  {
    noStroke();
    fill (player.left.get(x), mouseX + mouseY, 205, 5);
    ellipse (player.left.get(x)*800, x, random(50, 200), random (50, 200));
    ellipse ( x, player.right.get(x)*400, random(10, 90), random (56, 100));
  }

  if (keyPressed) {

    saveFrame();
  }
}


class Con {

  float n;
  float o;
  int p;

  Con( float _n, float _o, int _p) {

    n = _n;
    o = _o;
    p = _p;
  }

  void display() {

    noStroke();
    fill (mouseX, mouseY, 150);
    ellipse (n, o, 8, 15);
  }

  void move() {

    o = o + p;

    if ( o > height ) {
      o = 0;
    }
  }
}

